// AdSamplingView.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "AdSamplingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("Settings");
static TCHAR BASED_CODE szWindowPos[] = _T("AdSamplingPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = _stscanf(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's registry
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////








/////////////////////////////////////////////////////////////////////////////
// CAdSamplingView

IMPLEMENT_DYNCREATE(CAdSamplingView, CFormView)

CAdSamplingView::CAdSamplingView()
	: CFormView(CAdSamplingView::IDD)
{
	//{{AFX_DATA_INIT(CAdSamplingView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAdSamplingView::~CAdSamplingView()
{
}

void CAdSamplingView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdSamplingView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdSamplingView, CFormView)
	//{{AFX_MSG_MAP(CAdSamplingView)
	ON_WM_CLOSE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAdSamplingView diagnostics

#ifdef _DEBUG
void CAdSamplingView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAdSamplingView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAdSamplingView message handlers

void CAdSamplingView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	CScopeDoc *pDoc =(CScopeDoc*)m_pDocument;

	CView* pView;
	POSITION pos = pDoc->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = pDoc->GetNextView(pos);	
		if(pView->IsKindOf(RUNTIME_CLASS(CAdSamplingView)))
		{
			WINDOWPLACEMENT wp;
			if (!ReadWindowPlacement(&wp)) ResizeParentToFit();
			else pView->GetParentFrame()->SetWindowPlacement(&wp);
			break;
		}
	}

}

void CAdSamplingView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	
	CFormView::OnClose();
}

void CAdSamplingView::OnDestroy() 
{

	CScopeDoc *pDoc =(CScopeDoc*)m_pDocument;
	CView* pView;
	POSITION pos = pDoc->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = pDoc->GetNextView(pos);
		if(pView->IsKindOf(RUNTIME_CLASS(CAdSamplingView)))
		{
				// save the position of the window
				WINDOWPLACEMENT wp;
				wp.length = sizeof wp;
				if (pView->GetParentFrame()->GetWindowPlacement(&wp))
				{
					wp.flags = 0;
					if (IsZoomed())
						wp.flags |= WPF_RESTORETOMAXIMIZED;
					// and write it to the .INI file
					WriteWindowPlacement(&wp);
				}
		}
	}	
		
	CFormView::OnDestroy();
}
