// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "Scope.h"

#include "ChildFrm.h"
#include "ControlsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("Settings");
static TCHAR BASED_CODE szWindowPos[] = _T("Scope");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = _stscanf(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's registry
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////










/////////////////////////////////////////////////////////////////////////////
// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CChildFrame)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CChildFrame::CChildFrame()
{
	m_bSplitterCreated = FALSE;
	m_bShowPanel = false;
	// TODO: add member initialization code here
	
}

CChildFrame::~CChildFrame()
{

}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	if( !CMDIChildWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;

	return TRUE;	
}



/////////////////////////////////////////////////////////////////////////////
// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWnd::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers

BOOL CChildFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// create a splitter with 1 row, 2 columns
	if (!m_wndSplitter.CreateStatic(this, 1, 2))
	{
		TRACE0("Failed to CreateStaticSplitter\n");
	
		return FALSE;
	}

	// add the first splitter pane - the default view in column 0
	if (!m_wndSplitter.CreateView(0, 0,
		pContext->m_pNewViewClass, CSize(350, 100), pContext))
	{
		TRACE0("Failed to create first pane\n");

		return FALSE;
	}

	// add the second splitter pane - an input view in column 1
	if (!m_wndSplitter.CreateView(0, 1,
		RUNTIME_CLASS(CControlsView), CSize(0, 0), pContext))
	{
		TRACE0("Failed to create second pane\n");

		return FALSE;
	}

	// activate the input view
	SetActiveView((CView*)m_wndSplitter.GetPane(0,0));

	m_wndSplitter.LockBar(TRUE);

	m_wndSplitter.SetColumnInfo(1,250,100);

	m_bSplitterCreated = TRUE;
	m_bShowPanel = true;


	/*** Restore last Posstion ***/
/*	WINDOWPLACEMENT wp;
	if (ReadWindowPlacement(&wp))
	{
		SetWindowPlacement(&wp);
	}*/




	return TRUE;
}

void CChildFrame::OnSize(UINT nType, int cx, int cy) 
{	
	CMDIChildWnd::OnSize(nType, cx, cy);
	CRect rect;
	GetWindowRect( &rect );

	if( m_bSplitterCreated)  // m_bSplitterCreated set in OnCreateClient
	{
		if (m_bShowPanel == true)
		{
			if(rect.Width()> 250)  
			{
				m_wndSplitter.SetColumnInfo(0, rect.Width()-250, 0);
			}
			else 
			{
				m_wndSplitter.SetColumnInfo(0,0, 0);
			}

			m_wndSplitter.SetColumnInfo(1, 250, 0);
		}
		else
		{
			m_wndSplitter.SetColumnInfo(0, rect.Width(), 0);
			m_wndSplitter.SetColumnInfo(1, 0, 0);
		}

		m_wndSplitter.RecalcLayout();
	}
}

void CChildFrame::HideShowPanel()
{
	CRect rect;
	GetWindowRect(&rect);

	if( m_bSplitterCreated )  
	{
		if (m_bShowPanel == true) // Hide side panel
		{
			m_wndSplitter.SetColumnInfo(0, rect.Width(), 0);
			m_wndSplitter.SetColumnInfo(1, 0, 0);
			m_bShowPanel = false;
		}	
		else
		{
			if(rect.Width()> 200) // show side panel
			{
				m_wndSplitter.SetColumnInfo(0, rect.Width()-250, 0);
			}
			else 
			{
				m_wndSplitter.SetColumnInfo(0,0, 0);
			}
			m_wndSplitter.SetColumnInfo(1, 250, 0);
			m_bShowPanel = true;
		}
		
		m_wndSplitter.RecalcLayout();
	}
}



void CChildFrame::ShowPanel()
{
	CRect rect;
	GetWindowRect( &rect );
	if( m_bSplitterCreated )  // m_bSplitterCreated set in OnCreateClient
	{
		m_wndSplitter.SetColumnInfo(0, rect.Width(), 10);
		m_wndSplitter.SetColumnInfo(1, 250, 10);
		m_wndSplitter.RecalcLayout();
	}
	m_bShowPanel = true;
}

void CChildFrame::OnDestroy() 
{
	CMDIChildWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	
}

void CChildFrame::OnClose() 
{
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
	{
		wp.flags = 0;
		if (IsZoomed())
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		// and write it to the windows registry
		WriteWindowPlacement(&wp);
	}	

	CMDIChildWnd::OnClose();
}
