// ConfigPage1.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "ConfigPage1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigPage1 dialog


CConfigPage1::CConfigPage1(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigPage1::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigPage1)

	//}}AFX_DATA_INIT
}


void CConfigPage1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigPage1)
	DDX_Control(pDX, IDC_COM, m_Combo_COM);
	DDX_Control(pDX, IDC_STOIP_BITS, m_Combo_Stop_Bits);
	DDX_Control(pDX, IDC_Parity, m_Combo_Parity);
	DDX_Control(pDX, IDC_BYTE_SIZE, m_Combo_Byte_Size);
	DDX_Control(pDX, IDC_BAUD, m_Combo_Baud);
	DDX_Control(pDX, IDC_TIMER, m_CtrlTimer);
	DDX_Control(pDX, IDC_SPIN2, m_Spin_Timer);


	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigPage1, CDialog)
	//{{AFX_MSG_MAP(CConfigPage1)
	ON_CBN_EDITCHANGE(IDC_COM, OnChange)
	ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
	ON_CBN_SELCHANGE(IDC_COM, OnChange)
	ON_CBN_SELCHANGE(IDC_BAUD, OnChange)
	ON_CBN_EDITCHANGE(IDC_BAUD, OnChange)
	ON_CBN_SELCHANGE(IDC_BYTE_SIZE, OnChange)
	ON_CBN_EDITCHANGE(IDC_BYTE_SIZE, OnChange)
	ON_CBN_EDITCHANGE(IDC_Parity, OnChange)
	ON_CBN_SELCHANGE(IDC_Parity, OnChange)
	ON_CBN_EDITCHANGE(IDC_STOIP_BITS, OnChange)
	ON_CBN_SELCHANGE(IDC_STOIP_BITS, OnChange)
	ON_EN_CHANGE(IDC_TIMER, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigPage1 message handlers

BOOL CConfigPage1::OnInitDialog() 
{
	CDialog::OnInitDialog();
	

	m_Spin_Timer.SetBuddy(GetDlgItem(IDC_TIMER));
	m_Spin_Timer.SetRange32(1, 999);



	m_changes = false;

	CScopeApp* pApp = (CScopeApp*)AfxGetApp();


	m_Combo_COM.SetCurSel(pApp->GetProfileInt("Config","COM",D_COM));
	m_Combo_Baud.SetCurSel(pApp->GetProfileInt("Config","Baud",D_BAUD));
	m_Combo_Byte_Size.SetCurSel(pApp->GetProfileInt("Config","Byte Size",D_BYTE));
	m_Combo_Parity.SetCurSel(pApp->GetProfileInt("Config","Parity",D_PARITY));
	m_Combo_Stop_Bits.SetCurSel(pApp->GetProfileInt("Config","Stop Bits",D_STOP));
	SetDlgItemInt(IDC_TIMER,pApp->GetProfileInt("Config","Timer",D_TIMER));


	m_CtrlTimer.LimitText(3);


	OnChange();

	UpdateData(FALSE);




	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CConfigPage1::OnChange() 
{
	/* Compare Current with defaults */
	UpdateData(TRUE);

	if (m_Combo_COM.GetCurSel() == D_COM &&
		m_Combo_Baud.GetCurSel() == D_BAUD &&
		m_Combo_Byte_Size.GetCurSel() == D_BYTE &&
		m_Combo_Parity.GetCurSel() == D_PARITY &&
		m_Combo_Stop_Bits.GetCurSel() == D_STOP &&
		GetDlgItemInt(IDC_TIMER) == D_TIMER)
			GetDlgItem(IDC_DEFAULTS)->EnableWindow(FALSE);
	else
			GetDlgItem(IDC_DEFAULTS)->EnableWindow(TRUE);



	CheckforChanges();
}

void CConfigPage1::OnDefaults() 
{
	m_Combo_COM.SetCurSel(D_COM);
	m_Combo_Baud.SetCurSel(D_BAUD);
	m_Combo_Byte_Size.SetCurSel(D_BYTE);
	m_Combo_Parity.SetCurSel(D_PARITY);
	m_Combo_Stop_Bits.SetCurSel(D_STOP);
	SetDlgItemInt(IDC_TIMER,D_TIMER);



	UpdateData(false);

	OnChange();
}

void CConfigPage1::CheckforChanges()
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	bool ch = false;
 
	UpdateData(TRUE);

	if (pApp->GetProfileInt("Config","COM",D_COM) != (unsigned)m_Combo_COM.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Baud",D_BAUD) != (unsigned)m_Combo_Baud.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Byte Size",D_BYTE) != (unsigned)m_Combo_Byte_Size.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Parity",D_PARITY) != (unsigned)m_Combo_Parity.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Stop Bits",D_STOP) != (unsigned)m_Combo_Stop_Bits.GetCurSel()) ch = true;
	if (pApp->GetProfileInt("Config","Timer",D_TIMER) != GetDlgItemInt(IDC_TIMER)) ch = true;


	m_changes = ch;
}

void CConfigPage1::OnOK() 
{
	Save_Changes();
//	CDialog::OnOK();
}

void CConfigPage1::OnCancel() 
{
	// TODO: Add extra cleanup here
	
//	CDialog::OnCancel();
}

void CConfigPage1::Save_Changes()
{
	UpdateData(TRUE);
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	pApp->WriteProfileInt("Config","COM",m_Combo_COM.GetCurSel());
	pApp->WriteProfileInt("Config","Baud",m_Combo_Baud.GetCurSel());
	pApp->WriteProfileInt("Config","Byte Size",m_Combo_Byte_Size.GetCurSel());
	pApp->WriteProfileInt("Config","Parity",m_Combo_Parity.GetCurSel());
	pApp->WriteProfileInt("Config","Stop Bits",m_Combo_Stop_Bits.GetCurSel());
	pApp->WriteProfileInt("Config","Timer",GetDlgItemInt(IDC_TIMER));


	OnChange();
}
