// ControlsP1.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "ControlsP1.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlsP1 dialog


CControlsP1::CControlsP1(CWnd* pParent /*=NULL*/)
	: CDialog(CControlsP1::IDD, pParent)
{
	//{{AFX_DATA_INIT(CControlsP1)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CControlsP1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CControlsP1)
	DDX_Control(pDX, IDC_SAMPLE_RATE, m_CtrlSampleRate);
	DDX_Control(pDX, IDC_BUFFERSTATUS, m_ProgressBuffer);
	DDX_Control(pDX, IDC_INPUT_RANGE, m_Combo_InputRange);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CControlsP1, CDialog)
	//{{AFX_MSG_MAP(CControlsP1)
	ON_CBN_SELCHANGE(IDC_INPUT_RANGE, OnChange)
	ON_WM_TIMER()
	ON_CBN_DROPDOWN(IDC_INPUT_RANGE, OnDropDown)
	ON_CBN_CLOSEUP(IDC_INPUT_RANGE, OnCloseUp)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_REALTIME_SCROLL, OnRealtimeScroll)
	ON_BN_CLICKED(IDC_REALTIME_MODE, OnRealtimeMode)
	ON_CBN_EDITCHANGE(IDC_SAMPLE_RATE, OnEditchangeSampleRate)
	ON_CBN_SELCHANGE(IDC_SAMPLE_RATE, OnEditchangeSampleRate)
	ON_CBN_DROPDOWN(IDC_SAMPLE_RATE, OnDropDown)
	ON_CBN_CLOSEUP(IDC_SAMPLE_RATE, OnCloseUp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlsP1 message handlers

BOOL CControlsP1::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	pApp = (CScopeApp*)AfxGetApp();

	CheckDlgButton(IDC_REALTIME_MODE,pApp->m_nSampleMode);

	m_Combo_InputRange.SetCurSel(pApp->m_nInputRange);
	m_CtrlSampleRate.SetCurSel(pApp->m_SampleRateSelection);
	OnEditchangeSampleRate();

	OnChange();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CControlsP1::OnChange() 
{
	
	pApp->m_nInputRange = m_Combo_InputRange.GetCurSel();

	SetTimer(nTimerUpdateP1,250,NULL);
	SetTimer(nTimerBufferP1,100,NULL);
	m_ProgressBuffer.SetRange(0,pApp->m_nBufferSize);
}

void CControlsP1::OnTimer(UINT nIDEvent) 
{
	int up,low, m_OldSampleRate;

	if (nIDEvent == nTimerUpdateP1)
	{	
		m_OldSampleRate = m_CtrlSampleRate.GetCurSel();
		m_CtrlSampleRate.SetCurSel(pApp->m_SampleRateSelection);
		if (m_OldSampleRate != pApp->m_SampleRateSelection) pDoc->CalTimeBaseMUX();



		m_Combo_InputRange.SetCurSel(pApp->m_nInputRange);

		if(pApp->m_nSampleMode == 0) CheckDlgButton(IDC_REALTIME_SCROLL,BST_CHECKED);
		else CheckDlgButton(IDC_REALTIME_SCROLL,BST_UNCHECKED);
		
		if(pApp->m_nSampleMode == 1) CheckDlgButton(IDC_REALTIME_MODE,BST_CHECKED);
		else CheckDlgButton(IDC_REALTIME_MODE,BST_UNCHECKED);
	}

	if (nIDEvent == nTimerBufferP1)
	{
		m_ProgressBuffer.GetRange(low,up);
		if (up != pApp->m_nBufferSize) m_ProgressBuffer.SetRange(0,pApp->m_nBufferSize);
		m_ProgressBuffer.SetPos(pApp->m_nPOS);
	}

	CDialog::OnTimer(nIDEvent);
}

void CControlsP1::OnDropDown() 
{
	KillTimer(nTimerUpdateP1);
}

void CControlsP1::OnCloseUp() 
{
	SetTimer(nTimerUpdateP1,250,NULL);
}

void CControlsP1::OnDestroy() 
{
	CDialog::OnDestroy();
	
	KillTimer(nTimerUpdateP1);
}

void CControlsP1::OnRealtimeScroll() 
{
	pApp->m_nSampleMode = 0;
}

void CControlsP1::OnRealtimeMode() 
{
	pApp->m_nSampleMode = 1;
}

void CControlsP1::OnEditchangeSampleRate() 
{
	pApp->m_SampleRateSelection	= m_CtrlSampleRate.GetCurSel();
	pDoc->CalTimeBaseMUX();
}

void CControlsP1::Update()
{
	
}
