// ControlsP2.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "ControlsP2.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlsP2 dialog


CControlsP2::CControlsP2(CWnd* pParent /*=NULL*/)
	: CDialog(CControlsP2::IDD, pParent)
{
	//{{AFX_DATA_INIT(CControlsP2)
	m_C1 = FALSE;
	m_C2 = FALSE;
	m_C3 = FALSE;
	m_C4 = FALSE;
	//}}AFX_DATA_INIT
}


void CControlsP2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CControlsP2)
	DDX_Control(pDX, IDC_TIMEBASE, m_CtrlTimeBase);
	DDX_Control(pDX, IDC_STATIC_CH4, m_CH4);
	DDX_Control(pDX, IDC_STATIC_CH3, m_CH3);
	DDX_Control(pDX, IDC_STATIC_CH2, m_CH2);
	DDX_Control(pDX, IDC_STATIC_CH1, m_CH1);
	DDX_Control(pDX, IDC_CH4_VOLT, m_Combo_Ch4);
	DDX_Control(pDX, IDC_CH3_VOLT, m_Combo_Ch3);
	DDX_Control(pDX, IDC_CH2_VOLT, m_Combo_Ch2);
	DDX_Control(pDX, IDC_CH1_VOLT, m_Combo_Ch1);
	DDX_Check(pDX, IDC_CH1_ENABLE, m_C1);
	DDX_Check(pDX, IDC_CH2_ENABLE, m_C2);
	DDX_Check(pDX, IDC_CH3_ENABLE, m_C3);
	DDX_Check(pDX, IDC_CH4_ENABLE, m_C4);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CControlsP2, CDialog)
	//{{AFX_MSG_MAP(CControlsP2)
	ON_BN_CLICKED(IDC_CH1_ENABLE, OnEnaDisChannel)
	ON_CBN_SELCHANGE(IDC_CH1_VOLT, OnChange)
	ON_BN_CLICKED(IDC_STATIC_CH1, OnStaticCh1)
	ON_BN_CLICKED(IDC_STATIC_CH2, OnStaticCh2)
	ON_BN_CLICKED(IDC_STATIC_CH3, OnStaticCh3)
	ON_BN_CLICKED(IDC_STATIC_CH4, OnStaticCh4)
	ON_CBN_EDITCHANGE(IDC_TIMEBASE, OnEditchangeTimebase)
	ON_BN_CLICKED(IDC_CH2_ENABLE, OnEnaDisChannel)
	ON_BN_CLICKED(IDC_CH3_ENABLE, OnEnaDisChannel)
	ON_BN_CLICKED(IDC_CH4_ENABLE, OnEnaDisChannel)
	ON_CBN_SELCHANGE(IDC_CH2_VOLT, OnChange)
	ON_CBN_SELCHANGE(IDC_CH3_VOLT, OnChange)
	ON_CBN_SELCHANGE(IDC_CH4_VOLT, OnChange)
	ON_CBN_SELCHANGE(IDC_TIMEBASE, OnEditchangeTimebase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlsP2 message handlers

void CControlsP2::OnEnaDisChannel() 
{
	/** Enable Disable CH1 **/
	if(IsDlgButtonChecked(IDC_CH1_ENABLE) == BST_CHECKED)
	{
		GetDlgItem(IDC_CH1_VOLT)->EnableWindow(TRUE);
		pDoc->m_bCH1_ENABLE = true;
	}
	else
	{
		GetDlgItem(IDC_CH1_VOLT)->EnableWindow(FALSE);
		pDoc->m_bCH1_ENABLE = false;
	}

	/** Enable Disable CH2 **/
	if(IsDlgButtonChecked(IDC_CH2_ENABLE) == BST_CHECKED)
	{
		GetDlgItem(IDC_CH2_VOLT)->EnableWindow(TRUE);
		pDoc->m_bCH2_ENABLE = true;
	}
	else
	{
		GetDlgItem(IDC_CH2_VOLT)->EnableWindow(FALSE);
		pDoc->m_bCH2_ENABLE = false;
	}

	/** Enable Disable CH3 **/
	if(IsDlgButtonChecked(IDC_CH3_ENABLE) == BST_CHECKED)
	{
		GetDlgItem(IDC_CH3_VOLT)->EnableWindow(TRUE);
		pDoc->m_bCH3_ENABLE = true;
	}
	else
	{
		GetDlgItem(IDC_CH3_VOLT)->EnableWindow(FALSE);
		pDoc->m_bCH3_ENABLE = false;
	}

	/** Enable Disable CH4 **/
	if(IsDlgButtonChecked(IDC_CH4_ENABLE) == BST_CHECKED)
	{
		GetDlgItem(IDC_CH4_VOLT)->EnableWindow(TRUE);
		pDoc->m_bCH4_ENABLE = true;
	}
	else
	{
		GetDlgItem(IDC_CH4_VOLT)->EnableWindow(FALSE);
		pDoc->m_bCH4_ENABLE = false;
	}




}



BOOL CControlsP2::OnInitDialog() 
{
	CDialog::OnInitDialog();


	m_CH1.SetTextColor(RED);
	m_CH2.SetTextColor(GREEN);
	m_CH3.SetTextColor(BLUE);
	m_CH4.SetTextColor(MIDYELLOW);

/*	m_CH1.SetBkColor(BLACK);
	m_CH2.SetBkColor(BLACK);
	m_CH3.SetBkColor(BLACK);
	m_CH4.SetBkColor(BLACK);*/

	m_Combo_Ch1.SelectString(-1,_T("1V/DIV"));
	m_Combo_Ch2.SelectString(-1,_T("1V/DIV"));
	m_Combo_Ch3.SelectString(-1,_T("1V/DIV"));
	m_Combo_Ch4.SelectString(-1,_T("1V/DIV"));

	CheckDlgButton(IDC_CH1_ENABLE,BST_CHECKED);

	OnChange();
	OnEnaDisChannel();
	
	m_CtrlTimeBase.SetCurSel(7); 
	OnEditchangeTimebase();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CControlsP2::OnChange() 
{
	CString temp;

	/** Setup Channel 1 Volts per Dev **/
	GetDlgItemText(IDC_CH1_VOLT, temp);
	if (temp == _T("10mV/DIV")) pDoc->m_nCH1_VOLTS = 1;
	if (temp == _T("20mV/DIV")) pDoc->m_nCH1_VOLTS = 2;
	if (temp == _T("50mV/DIV")) pDoc->m_nCH1_VOLTS = 5;
	if (temp == _T(".1V/DIV")) pDoc->m_nCH1_VOLTS = 10;
	if (temp == _T(".2V/DIV")) pDoc->m_nCH1_VOLTS = 20;
	if (temp == _T(".5V/DIV")) pDoc->m_nCH1_VOLTS = 50;
	if (temp == _T("1V/DIV")) pDoc->m_nCH1_VOLTS = 100;
	if (temp == _T("2V/DIV")) pDoc->m_nCH1_VOLTS = 200;
	if (temp == _T("5V/DIV")) pDoc->m_nCH1_VOLTS = 500;
	if (temp == _T("10V/DIV")) pDoc->m_nCH1_VOLTS = 1000;
	if (temp == _T("20V/DIV")) pDoc->m_nCH1_VOLTS = 2000;
	if (temp == _T("50V/DIV")) pDoc->m_nCH1_VOLTS = 5000;


	/** Setup Channel 2 Volts per Dev **/
	GetDlgItemText(IDC_CH2_VOLT, temp);
	if (temp == _T("10mV/DIV")) pDoc->m_nCH2_VOLTS = 1;
	if (temp == _T("20mV/DIV")) pDoc->m_nCH2_VOLTS = 2;
	if (temp == _T("50mV/DIV")) pDoc->m_nCH2_VOLTS = 5;
	if (temp == _T(".1V/DIV")) pDoc->m_nCH2_VOLTS = 10;
	if (temp == _T(".2V/DIV")) pDoc->m_nCH2_VOLTS = 20;
	if (temp == _T(".5V/DIV")) pDoc->m_nCH2_VOLTS = 50;
	if (temp == _T("1V/DIV")) pDoc->m_nCH2_VOLTS = 100;
	if (temp == _T("2V/DIV")) pDoc->m_nCH2_VOLTS = 200;
	if (temp == _T("5V/DIV")) pDoc->m_nCH2_VOLTS = 500;
	if (temp == _T("10V/DIV")) pDoc->m_nCH2_VOLTS = 1000;
	if (temp == _T("20V/DIV")) pDoc->m_nCH2_VOLTS = 2000;
	if (temp == _T("50V/DIV")) pDoc->m_nCH2_VOLTS = 5000;

	/** Setup Channel 3 Volts per Dev **/
	GetDlgItemText(IDC_CH3_VOLT, temp);
	if (temp == _T("10mV/DIV")) pDoc->m_nCH3_VOLTS = 1;
	if (temp == _T("20mV/DIV")) pDoc->m_nCH3_VOLTS = 2;
	if (temp == _T("50mV/DIV")) pDoc->m_nCH3_VOLTS = 5;
	if (temp == _T(".1V/DIV")) pDoc->m_nCH3_VOLTS = 10;
	if (temp == _T(".2V/DIV")) pDoc->m_nCH3_VOLTS = 20;
	if (temp == _T(".5V/DIV")) pDoc->m_nCH3_VOLTS = 50;
	if (temp == _T("1V/DIV")) pDoc->m_nCH3_VOLTS = 100;
	if (temp == _T("2V/DIV")) pDoc->m_nCH3_VOLTS = 200;
	if (temp == _T("5V/DIV")) pDoc->m_nCH3_VOLTS = 500;
	if (temp == _T("10V/DIV")) pDoc->m_nCH3_VOLTS = 1000;
	if (temp == _T("20V/DIV")) pDoc->m_nCH3_VOLTS = 2000;
	if (temp == _T("50V/DIV")) pDoc->m_nCH3_VOLTS = 5000;

	/** Setup Channel 4 Volts per Dev **/
	GetDlgItemText(IDC_CH4_VOLT, temp);
	if (temp == _T("10mV/DIV")) pDoc->m_nCH4_VOLTS = 1;
	if (temp == _T("20mV/DIV")) pDoc->m_nCH4_VOLTS = 2;
	if (temp == _T("50mV/DIV")) pDoc->m_nCH4_VOLTS = 5;
	if (temp == _T(".1V/DIV")) pDoc->m_nCH4_VOLTS = 10;
	if (temp == _T(".2V/DIV")) pDoc->m_nCH4_VOLTS = 20;
	if (temp == _T(".5V/DIV")) pDoc->m_nCH4_VOLTS = 50;
	if (temp == _T("1V/DIV")) pDoc->m_nCH4_VOLTS = 100;
	if (temp == _T("2V/DIV")) pDoc->m_nCH4_VOLTS = 200;
	if (temp == _T("5V/DIV")) pDoc->m_nCH4_VOLTS = 500;
	if (temp == _T("10V/DIV")) pDoc->m_nCH4_VOLTS = 1000;
	if (temp == _T("20V/DIV")) pDoc->m_nCH4_VOLTS = 2000;
	if (temp == _T("50V/DIV")) pDoc->m_nCH4_VOLTS = 5000;
}



void CControlsP2::OnStaticCh1() 
{
	if (IsDlgButtonChecked(IDC_CH1_ENABLE) == TRUE)
		CheckDlgButton(IDC_CH1_ENABLE,BST_UNCHECKED);
	else
		CheckDlgButton(IDC_CH1_ENABLE,BST_CHECKED);

	OnChange();
	OnEnaDisChannel();
}

void CControlsP2::OnStaticCh2() 
{
	if (IsDlgButtonChecked(IDC_CH2_ENABLE) == TRUE)
		CheckDlgButton(IDC_CH2_ENABLE,BST_UNCHECKED);
	else
		CheckDlgButton(IDC_CH2_ENABLE,BST_CHECKED);

	OnChange();
	OnEnaDisChannel();
}

void CControlsP2::OnStaticCh3() 
{
	if (IsDlgButtonChecked(IDC_CH3_ENABLE) == TRUE)
		CheckDlgButton(IDC_CH3_ENABLE,BST_UNCHECKED);
	else
		CheckDlgButton(IDC_CH3_ENABLE,BST_CHECKED);

	OnChange();
	OnEnaDisChannel();
}

void CControlsP2::OnStaticCh4() 
{
	if (IsDlgButtonChecked(IDC_CH4_ENABLE) == TRUE)
		CheckDlgButton(IDC_CH4_ENABLE,BST_UNCHECKED);
	else
		CheckDlgButton(IDC_CH4_ENABLE,BST_CHECKED);

	OnChange();
	OnEnaDisChannel();
}

void CControlsP2::OnEditchangeTimebase() 
{
	pDoc->m_TimeBaseSelection = m_CtrlTimeBase.GetCurSel();
	pDoc->CalTimeBaseMUX();	
}

void CControlsP2::Update()
{
	m_C1 = pDoc->m_bCH1_ENABLE;
	m_C2 = pDoc->m_bCH2_ENABLE;
	m_C3 = pDoc->m_bCH3_ENABLE;
	m_C4 = pDoc->m_bCH4_ENABLE;

	UpdateData(FALSE);

	m_CtrlTimeBase.SetCurSel(pDoc->m_TimeBaseSelection);
	pDoc->CalTimeBaseMUX();	

	switch(pDoc->m_nCH1_VOLTS)
	{
		case 1: m_Combo_Ch1.SelectString(-1,_T("10mV/DIV")); break;
		case 2: m_Combo_Ch1.SelectString(-1,_T("20mV/DIV")); break;
		case 5: m_Combo_Ch1.SelectString(-1,_T("50mV/DIV")); break;
		case 10: m_Combo_Ch1.SelectString(-1,_T(".1V/DIV")); break;
		case 20: m_Combo_Ch1.SelectString(-1,_T(".2V/DIV")); break;
		case 50: m_Combo_Ch1.SelectString(-1,_T(".5V/DIV")); break;
		case 100: m_Combo_Ch1.SelectString(-1,_T("1V/DIV")); break;
		case 200: m_Combo_Ch1.SelectString(-1,_T("2V/DIV")); break;
		case 500: m_Combo_Ch1.SelectString(-1,_T("5V/DIV")); break;
		case 1000: m_Combo_Ch1.SelectString(-1,_T("10V/DIV")); break;
		case 2000: m_Combo_Ch1.SelectString(-1,_T("20V/DIV")); break;
		case 5000: m_Combo_Ch1.SelectString(-1,_T("50V/DIV")); break;
	}

	switch(pDoc->m_nCH2_VOLTS)
	{
		case 1: m_Combo_Ch2.SelectString(-1,_T("10mV/DIV")); break;
		case 2: m_Combo_Ch2.SelectString(-1,_T("20mV/DIV")); break;
		case 5: m_Combo_Ch2.SelectString(-1,_T("50mV/DIV")); break;
		case 10: m_Combo_Ch2.SelectString(-1,_T(".1V/DIV")); break;
		case 20: m_Combo_Ch2.SelectString(-1,_T(".2V/DIV")); break;
		case 50: m_Combo_Ch2.SelectString(-1,_T(".5V/DIV")); break;
		case 100: m_Combo_Ch2.SelectString(-1,_T("1V/DIV")); break;
		case 200: m_Combo_Ch2.SelectString(-1,_T("2V/DIV")); break;
		case 500: m_Combo_Ch2.SelectString(-1,_T("5V/DIV")); break;
		case 1000: m_Combo_Ch2.SelectString(-1,_T("10V/DIV")); break;
		case 2000: m_Combo_Ch2.SelectString(-1,_T("20V/DIV")); break;
		case 5000: m_Combo_Ch2.SelectString(-1,_T("50V/DIV")); break;
	}

	switch(pDoc->m_nCH3_VOLTS)
	{
		case 1: m_Combo_Ch3.SelectString(-1,_T("10mV/DIV")); break;
		case 2: m_Combo_Ch3.SelectString(-1,_T("20mV/DIV")); break;
		case 5: m_Combo_Ch3.SelectString(-1,_T("50mV/DIV")); break;
		case 10: m_Combo_Ch3.SelectString(-1,_T(".1V/DIV")); break;
		case 20: m_Combo_Ch3.SelectString(-1,_T(".2V/DIV")); break;
		case 50: m_Combo_Ch3.SelectString(-1,_T(".5V/DIV")); break;
		case 100: m_Combo_Ch3.SelectString(-1,_T("1V/DIV")); break;
		case 200: m_Combo_Ch3.SelectString(-1,_T("2V/DIV")); break;
		case 500: m_Combo_Ch3.SelectString(-1,_T("5V/DIV")); break;
		case 1000: m_Combo_Ch3.SelectString(-1,_T("10V/DIV")); break;
		case 2000: m_Combo_Ch3.SelectString(-1,_T("20V/DIV")); break;
		case 5000: m_Combo_Ch3.SelectString(-1,_T("50V/DIV")); break;
	}

	switch(pDoc->m_nCH4_VOLTS)
	{
		case 1: m_Combo_Ch4.SelectString(-1,_T("10mV/DIV")); break;
		case 2: m_Combo_Ch4.SelectString(-1,_T("20mV/DIV")); break;
		case 5: m_Combo_Ch4.SelectString(-1,_T("50mV/DIV")); break;
		case 10: m_Combo_Ch4.SelectString(-1,_T(".1V/DIV")); break;
		case 20: m_Combo_Ch4.SelectString(-1,_T(".2V/DIV")); break;
		case 50: m_Combo_Ch4.SelectString(-1,_T(".5V/DIV")); break;
		case 100: m_Combo_Ch4.SelectString(-1,_T("1V/DIV")); break;
		case 200: m_Combo_Ch4.SelectString(-1,_T("2V/DIV")); break;
		case 500: m_Combo_Ch4.SelectString(-1,_T("5V/DIV")); break;
		case 1000: m_Combo_Ch4.SelectString(-1,_T("10V/DIV")); break;
		case 2000: m_Combo_Ch4.SelectString(-1,_T("20V/DIV")); break;
		case 5000: m_Combo_Ch4.SelectString(-1,_T("50V/DIV")); break;
	}

	OnEnaDisChannel();
}
