// ControlsP3.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "ControlsP3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CControlsP3 dialog


CControlsP3::CControlsP3(CWnd* pParent /*=NULL*/)
	: CDialog(CControlsP3::IDD, pParent)
{
	//{{AFX_DATA_INIT(CControlsP3)
	m_Level = 0;
	//}}AFX_DATA_INIT
}


void CControlsP3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CControlsP3)
	DDX_Control(pDX, IDC_LEVEL, m_Ctrl_Level);
	DDX_Control(pDX, IDC_SPIN_LEVEL, m_Spin_Level);
	DDX_Control(pDX, IDC_TRIGGER, m_Combo_Trigger);
	DDX_Text(pDX, IDC_LEVEL, m_Level);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CControlsP3, CDialog)
	//{{AFX_MSG_MAP(CControlsP3)
	ON_CBN_SELCHANGE(IDC_TRIGGER, OnSelchangeTrigger)
	ON_CBN_DROPDOWN(IDC_TRIGGER, OnDropdownTrigger)
	ON_CBN_CLOSEUP(IDC_TRIGGER, OnCloseupTrigger)
	ON_BN_CLICKED(IDC_TRIG_NEG_TO_POS, OnTrigNegToPos)
	ON_BN_CLICKED(IDC_TRIG_POS_TO_NEG, OnTrigPosToNeg)
	ON_EN_CHANGE(IDC_LEVEL, OnChangeLevel)
	ON_BN_CLICKED(IDC_LEVEL_TRIGGER, OnLevelTrigger)
	ON_BN_CLICKED(IDC_STATIC1, OnTrigPosToNeg)
	ON_BN_CLICKED(IDC_STATIC2, OnTrigPosToNeg)
	ON_BN_CLICKED(IDC_STATIC3, OnTrigNegToPos)
	ON_BN_CLICKED(IDC_STATIC4, OnTrigNegToPos)
	ON_BN_CLICKED(IDC_EDGED_TRIGGERED, OnEdgedTriggered)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CControlsP3 message handlers

BOOL CControlsP3::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	pApp = (CScopeApp*)AfxGetApp();

	//m_Combo_Trigger.SelectString(-1,_T("CH1"));
	m_Combo_Trigger.SetCurSel(pDoc->m_nTrigger); 
	
	m_Spin_Level.SetBuddy(GetDlgItem(IDC_LEVEL));
	m_Spin_Level.SetRange32(-99, 99);
	m_Ctrl_Level.LimitText(2);

	SetDlgItemInt(IDC_LEVEL,pDoc->m_nTriggerOffsetLevel);

	if (pDoc->m_nTriggerType == 0)
	{
		CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_CHECKED);
		CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_UNCHECKED);
	}

	else 
	{
		CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_CHECKED);
		CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_UNCHECKED);
	}

	if (pDoc->m_nTriggerFormat == 0)
	{
		CheckDlgButton(IDC_LEVEL_TRIGGER,BST_CHECKED);
		CheckDlgButton(IDC_EDGED_TRIGGERED,BST_UNCHECKED);
		GetDlgItem(IDC_LEVEL)->EnableWindow(TRUE);
		GetDlgItem(IDC_SPIN_LEVEL)->EnableWindow(TRUE);
	}

	else 
	{
		CheckDlgButton(IDC_EDGED_TRIGGERED,BST_CHECKED);
		CheckDlgButton(IDC_LEVEL_TRIGGER,BST_UNCHECKED);
		GetDlgItem(IDC_LEVEL)->EnableWindow(FALSE);
		GetDlgItem(IDC_SPIN_LEVEL)->EnableWindow(FALSE);
	}


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CControlsP3::OnSelchangeTrigger() 
{

	pDoc->m_nTrigger = m_Combo_Trigger.GetCurSel();
	


	m_Combo_Trigger.SetCurSel(pDoc->m_nTrigger); 
}

void CControlsP3::OnDropdownTrigger() 
{


}

void CControlsP3::OnCloseupTrigger() 
{
	// TODO: Add your control notification handler code here
	
}

void CControlsP3::OnTrigNegToPos() 
{	
	CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_CHECKED);
	CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_UNCHECKED);
	pDoc->m_nTriggerType = 0;
}

void CControlsP3::OnTrigPosToNeg() 
{
	CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_UNCHECKED);
	CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_CHECKED);
	pDoc->m_nTriggerType = 1;
}

void CControlsP3::Update()
{
	m_Combo_Trigger.SetCurSel(pDoc->m_nTrigger); 

	if (pDoc->m_nTriggerType == 0)
	{
		CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_CHECKED);
		CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_UNCHECKED);
	}

	else 
	{
		CheckDlgButton(IDC_TRIG_POS_TO_NEG,BST_CHECKED);
		CheckDlgButton(IDC_TRIG_NEG_TO_POS,BST_UNCHECKED);
	}
}

void CControlsP3::OnChangeLevel() 
{
	UpdateData(TRUE);
	pDoc->m_nTriggerOffsetLevel = m_Level * -1000;
}

void CControlsP3::OnLevelTrigger() 
{
	CheckDlgButton(IDC_LEVEL_TRIGGER,BST_CHECKED);
	CheckDlgButton(IDC_EDGED_TRIGGERED,BST_UNCHECKED);
	GetDlgItem(IDC_LEVEL)->EnableWindow(TRUE);
	GetDlgItem(IDC_SPIN_LEVEL)->EnableWindow(TRUE);
	pDoc->m_nTriggerFormat = 0;
}

void CControlsP3::OnEdgedTriggered() 
{
	CheckDlgButton(IDC_EDGED_TRIGGERED,BST_CHECKED);
	CheckDlgButton(IDC_LEVEL_TRIGGER,BST_UNCHECKED);
	GetDlgItem(IDC_LEVEL)->EnableWindow(FALSE);
	GetDlgItem(IDC_SPIN_LEVEL)->EnableWindow(FALSE);
	pDoc->m_nTriggerFormat = 1;
}
