// GridConfigDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scope.h"
#include "GridConfigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGridConfigDlg dialog


CGridConfigDlg::CGridConfigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGridConfigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGridConfigDlg)
	m_Y = 0;
	m_X = 0;
	m_RefreshRate = 0;
	m_nBufferSize = 0;
	m_AutoBuffer = TRUE;
	//}}AFX_DATA_INIT
}


void CGridConfigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGridConfigDlg)
	DDX_Control(pDX, IDC_REFRESH, m_CtrlRefresh);
	DDX_Control(pDX, IDC_BUFFER_SIZE, m_CtrlBuffer);
	DDX_Control(pDX, IDC_X, m_CtrlX);
	DDX_Control(pDX, IDC_Y, m_CtrlY);
	DDX_Text(pDX, IDC_Y, m_Y);
	DDX_Text(pDX, IDC_X, m_X);
	DDX_Text(pDX, IDC_REFRESH, m_RefreshRate);
	DDX_Text(pDX, IDC_BUFFER_SIZE, m_nBufferSize);
	DDX_Check(pDX, IDC_AUTO_BUFFER, m_AutoBuffer);
	//}}AFX_DATA_MAP
}


void CGridConfigDlg::OnBackgroundColour() 
{
	CColorDialog dlg;
	
	if (dlg.DoModal() == IDOK)
	{
			m_ColorGridBackGround = dlg.GetColor();
	}

}

BEGIN_MESSAGE_MAP(CGridConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CGridConfigDlg)
	ON_BN_CLICKED(IDC_BACKGROUND_COLOUR, OnBackgroundColour)
	ON_EN_CHANGE(IDC_X, OnChangeX)
	ON_BN_CLICKED(IDC_AUTO_BUFFER, OnAutoBuffer)
	ON_EN_CHANGE(IDC_Y, OnChangeY)
	ON_EN_CHANGE(IDC_BUFFER_SIZE, OnChangeBufferSize)
	ON_EN_CHANGE(IDC_REFRESH, OnChangeRefresh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGridConfigDlg message handlers



BOOL CGridConfigDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	m_CtrlX.LimitText(2);
	m_CtrlY.LimitText(2);
	m_CtrlBuffer.LimitText(4);
	m_CtrlRefresh.LimitText(3);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGridConfigDlg::OnChangeX() 
{
	if (GetDlgItemInt(IDC_X) == 0) SetDlgItemInt(IDC_X,1);

	if(m_AutoBuffer == TRUE) SetDlgItemInt(IDC_BUFFER_SIZE,GetDlgItemInt(IDC_X)*40+1);
}



void CGridConfigDlg::OnAutoBuffer() 
{
	UpdateData(TRUE);
	if(m_AutoBuffer == TRUE) SetDlgItemInt(IDC_BUFFER_SIZE,GetDlgItemInt(IDC_X)*40+1);
}

void CGridConfigDlg::OnChangeY() 
{
	if (GetDlgItemInt(IDC_Y) == 0) SetDlgItemInt(IDC_Y,1);
}

void CGridConfigDlg::OnChangeBufferSize() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if (GetDlgItemInt(IDC_BUFFER_SIZE) < 100) SetDlgItemInt(IDC_BUFFER_SIZE,100);
}

void CGridConfigDlg::OnChangeRefresh() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
	if (GetDlgItemInt(IDC_REFRESH) == 0) SetDlgItemInt(IDC_REFRESH,1);

}
