// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Scope.h"

#include "MainFrm.h"
#include "ScopeDoc.h"
#include "ControlsView.h"
#include "ConfigurationDlg.h"
#include "ChildFrm.h"
#include "AdSamplingView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_CONTROLS, OnViewControls)
	ON_COMMAND(ID_TOOLS_CONFIGURATION, OnToolsConfiguration)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_CLOSE()
	ON_WM_MEASUREITEM()
	ON_WM_MENUCHAR()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_HELP_COLINSHOMEPAGE, OnHelpColinsHomePage)
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_HIDESHOWSIDEBAR, OnUpdateHideShowSidebar)
	ON_COMMAND(ID_VIEW_AD_SAMPLING, OnViewAdSampling)
	ON_COMMAND(ID_ENABLE_COMMS, OnEnableComms)
	ON_COMMAND(ID_DISABLE_COMMS, OnDisableComms)
	ON_UPDATE_COMMAND_UI(ID_ENABLE_COMMS, OnUpdateEnableComms)
	ON_UPDATE_COMMAND_UI(ID_DISABLE_COMMS, OnUpdateDisableComms)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


/////////////////////////////////////////////////////////////////////////////
// saving/restoring window state

static TCHAR BASED_CODE szSection[] = _T("Settings");
static TCHAR BASED_CODE szWindowPos[] = _T("WindowPos");
static TCHAR szFormat[] = _T("%u,%u,%d,%d,%d,%d,%d,%d,%d,%d");

static BOOL PASCAL NEAR ReadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp()->GetProfileString(szSection, szWindowPos);
	if (strBuffer.IsEmpty())
		return FALSE;

	WINDOWPLACEMENT wp;
	int nRead = _stscanf(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);

	if (nRead != 10)
		return FALSE;

	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

static void PASCAL NEAR WriteWindowPlacement(LPWINDOWPLACEMENT pwp)
	// write a window placement to settings section of app's registry
{
	TCHAR szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];

	wsprintf(szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString(szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////



/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_bEnableCOMS = false;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();


	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	InitalCom();

	PurgeComm(m_hCom,PURGE_RXCLEAR);
	CH1_POS = 0;
	CH2_POS = 0;
	CH3_POS = 0;
	CH4_POS = 0;

	SetTimer(TIMER_COMMS,pApp->GetProfileInt("Config","Timer",D_TIMER),NULL);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::CreateOrActivateFrame(CDocTemplate *pTemplate, CRuntimeClass *pViewClass)
{
	// if already exists, then activate the MDI child window containing
	// the view.  Otherwise, create a new view for the document.
	// If the MDI child window already exists and activate, the MDI child
	// window containing the view will be destoryed.

	CMDIChildWnd* pMDIActive = MDIGetActive();
	if(pMDIActive == NULL) return;
	CDocument* pDoc = pMDIActive->GetActiveDocument();
	if ( pDoc == NULL) return;

	CString Title;
	CView* pView;
	POSITION pos = pDoc->GetFirstViewPosition();
	
	if (pos != NULL)
	{
		pView = pDoc->GetNextView(pos);
		pView->GetParentFrame()->GetWindowText(Title);
	}


	/* Close window if active, WARNING any changes will be lost */
	CString temp;
	pMDIActive->GetWindowText(temp);
	if(temp == m_Title)
	{

		pos = pDoc->GetFirstViewPosition();
		while (pos != NULL)
		{
			pView = pDoc->GetNextView(pos);
			if (pView->IsKindOf(pViewClass))
			{
				pView->GetParentFrame()->DestroyWindow();
				return;
			}
		}
	}	



	pos = pDoc->GetFirstViewPosition();
	while (pos != NULL)
	{
		pView = pDoc->GetNextView(pos);
		if (pView->IsKindOf(pViewClass))
		{
			pView->GetParentFrame()->ActivateFrame();
			return;
		}
	}

	CMDIChildWnd* pNewFrame = (CMDIChildWnd*)(pTemplate->CreateNewFrame(pDoc, NULL));
	
	if (pNewFrame == NULL)
		return;     // not created
	ASSERT_KINDOF(CMDIChildWnd, pNewFrame);

	pTemplate->InitialUpdateFrame(pNewFrame, pDoc);
	pNewFrame->SetWindowText(m_Title);
}

void CMainFrame::OnViewControls() 
{
	CMDIChildWnd* pMDIActive = MDIGetActive();
	if(pMDIActive == NULL) return;
	CScopeDoc* pDoc = (CScopeDoc*)pMDIActive->GetActiveDocument();
	if ( pDoc == NULL) return;
//	m_Title.Format("Controls",pDoc->m_Slave);
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	CreateOrActivateFrame(pApp->GetControlsView(),RUNTIME_CLASS(CControlsView));
}

void CMainFrame::InitalCom()
{
	/* 24/12/01 by colin mccord */ 

	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	int temp_int;
	DWORD baud;
	BYTE partiy, byte, StopBits;

	temp_int = pApp->GetProfileInt("Config","COM",D_COM);
	if(temp_int == 0)		m_sComPort = "Com1";
	else if(temp_int == 1) 	m_sComPort = "Com2";
	else if(temp_int == 2) 	m_sComPort = "Com3";
	else if(temp_int == 3) 	m_sComPort = "Com4";
	else 					m_sComPort = "Com1";

	temp_int = pApp->GetProfileInt("Config","Baud",D_BAUD);
	if (temp_int == 0)		baud = 1200;
	else if(temp_int == 1)	baud = 2400;
	else if(temp_int == 2)	baud = 4800;
	else if(temp_int == 3)	baud = 9600;
	else if(temp_int == 4) 	baud = 14400;
	else if(temp_int == 5) 	baud = 19200;
	else if(temp_int == 6) 	baud = 32768;
	else if(temp_int == 7) 	baud = 38400;
	else if(temp_int == 8) 	baud = 57600;
	else if(temp_int == 9)  baud = 115200;
	else baud = 9600;

	temp_int = pApp->GetProfileInt("Config","Byte Size",D_BYTE);
	if(temp_int == 0)		byte = 7;
	else if(temp_int == 1) 	byte = 8;
	else 					byte = 8;

	temp_int = pApp->GetProfileInt("Config","Parity",D_PARITY);
	if(temp_int == 0)		partiy = EVENPARITY;
	else if(temp_int == 1) 	partiy = MARKPARITY;
	else if(temp_int == 2) 	partiy = NOPARITY;
	else if(temp_int == 3) 	partiy = ODDPARITY;
	else if(temp_int == 4) 	partiy = SPACEPARITY;
	else partiy = NOPARITY;

	temp_int = pApp->GetProfileInt("Config","Stop Bits",D_STOP);
	if(temp_int == 0)		StopBits = ONESTOPBIT;
	else if(temp_int == 1) 	StopBits = ONE5STOPBITS;
	else if(temp_int == 2) 	StopBits = TWOSTOPBITS;
	else 					StopBits = ONESTOPBIT;


	m_hCom = CreateFile(m_sComPort, 
		GENERIC_READ | GENERIC_WRITE,
		0,		// exclusive access
		NULL,	// no security
		OPEN_EXISTING,
		0,		// no overlapped I/O
		NULL);	// null template 


	// Check the returned handle for INVALID_HANDLE_VALUE and then 
	// set the buffer sizes.

	m_bPortReady = SetupComm(m_hCom, 10000, 1000); // set buffer sizes


	m_bPortReady = GetCommState(m_hCom, &m_dcb);
	m_dcb.BaudRate = baud;
	m_dcb.ByteSize = byte;
	m_dcb.Parity = partiy;
	m_dcb.StopBits = ONESTOPBIT;

	m_bPortReady = SetCommState(m_hCom, &m_dcb);


	m_bPortReady = GetCommTimeouts (m_hCom, &m_CommTimeouts);

	m_CommTimeouts.ReadIntervalTimeout = 5;
	m_CommTimeouts.ReadTotalTimeoutConstant = 5;
	m_CommTimeouts.ReadTotalTimeoutMultiplier = 5;
	m_CommTimeouts.WriteTotalTimeoutConstant = 10;
	m_CommTimeouts.WriteTotalTimeoutMultiplier = 10;

	m_bPortReady = SetCommTimeouts (m_hCom, &m_CommTimeouts);
}

bool CMainFrame::readchr(unsigned char *c)
{
	unsigned char   Buffer[128];

	unsigned long a = 0;
	bReadRC = ReadFile(m_hCom, &Buffer, 1, &a, NULL);

	if (a == 0) return false; // No char recived
	else
	{
		*c = Buffer[0];
		return true;
	}
}

void CMainFrame::trans(char c)
{
	char buffer[2];
	buffer[0] = c;
	bWriteRC = WriteFile (m_hCom, buffer, 1,&iBytesWritten,NULL);
}

void CMainFrame::OnToolsConfiguration() 
{
	CConfigurationDlg dlg;
	dlg.DoModal();

	/* Reinital Comms */
	CloseHandle (m_hCom);
	InitalCom();
}

void CMainFrame::OnDestroy() 
{
	CMDIFrameWnd::OnDestroy();
	CloseHandle (m_hCom);
	KillTimer(TIMER_COMMS);
}

void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	if (nIDEvent == TIMER_COMMS)
	{
			KillTimer(TIMER_COMMS);
			
		
			if(m_bEnableCOMS == true) 
			{
				ComProtocolTop();
			}
			else PurgeComm(m_hCom,PURGE_RXCLEAR);

			SetTimer(TIMER_COMMS,pApp->GetProfileInt("Config","Timer",D_TIMER),NULL);
	}
	CMDIFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::ComProtocolTop()
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
		


	switch(pApp->m_nSampleMode)
	{
		case 0: ComRealTimeScroll(); break;
		case 1:	ComRealTimeBuffered(); break;
		default: ComRealTimeBuffered(); break;
	}

}

void CMainFrame::InitialShowWindow(UINT nCmdShow)
{
	/** Restore window position from registry, by CKM 05/02/2002 **/
	WINDOWPLACEMENT wp;
	if (!ReadWindowPlacement(&wp))
	{
		ShowWindow(nCmdShow);
		return;
	}
	if (nCmdShow != SW_SHOWNORMAL) wp.showCmd = nCmdShow;
	SetWindowPlacement(&wp);
	ShowWindow(wp.showCmd);
}

void CMainFrame::OnClose() 
{
	// before it is destroyed, save the position of the window
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if (GetWindowPlacement(&wp))
	{
		wp.flags = 0;
		if (IsZoomed())
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		// and write it to the windows registry
		WriteWindowPlacement(&wp);
	}	

	CMDIFrameWnd::OnClose();
}

HMENU CMainFrame::NewMenu()
{
	static UINT toolbars[]=
	{
		IDR_MAINFRAME,
		IDR_TOOLBAR
	};

	// Load the menu from the resources
	// ****replace IDR_MENUTYPE with your menu ID****
	m_menu.LoadMenu(IDR_SCOPETYPE);  
	// One method for adding bitmaps to menu options is 
	// through the LoadToolbars member function.This method 
	// allows you to add all the bitmaps in a toolbar object 
	// to menu options (if they exist). The first function 
	// parameter is an array of toolbar id's. The second is 
	// the number of toolbar id's. There is also a function 
	// called LoadToolbar that just takes an id.
	m_menu.LoadToolbars(toolbars,2);

	return(m_menu.Detach());
}

HMENU CMainFrame::NewDefaultMenu()
{
	m_default.LoadMenu(IDR_MAINFRAME);
	m_default.LoadToolbar(IDR_MAINFRAME);
	return(m_default.Detach());
}

void CMainFrame::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct) 
{
	//This handler ensure that the popup menu items are 
	// drawn correctly

	BOOL setflag=FALSE;

	if(lpMeasureItemStruct->CtlType==ODT_MENU)
	{
		if(IsMenu((HMENU)lpMeasureItemStruct->itemID))
		{
			CMenu* cmenu = 
			CMenu::FromHandle((HMENU)lpMeasureItemStruct->itemID);

			if(m_menu.IsMenu(cmenu)||m_default.IsMenu(cmenu))
			{
					m_menu.MeasureItem(lpMeasureItemStruct);
					setflag=TRUE;
			}
		}
	}

	if(!setflag)CMDIFrameWnd::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

LRESULT CMainFrame::OnMenuChar(UINT nChar, UINT nFlags, CMenu* pMenu) 
{
	//This handler ensures that keyboard shortcuts work
	LRESULT lresult;
	if(m_menu.IsMenu(pMenu)||m_default.IsMenu(pMenu))
		lresult=BCMenu::FindKeyboardShortcut(nChar, nFlags, pMenu);
	else
		lresult=CMDIFrameWnd::OnMenuChar(nChar, nFlags, pMenu);
	return(lresult);
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	//This handler updates the menus from time to time
	CMDIFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	
	CMDIFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	if(!bSysMenu)
	{
		if(m_menu.IsMenu(pPopupMenu)||m_default.IsMenu(pPopupMenu))
		BCMenu::UpdateMenu(pPopupMenu);
	}
	
}

void CMainFrame::OnHelpColinsHomePage() 
{
	ShellExecute(::GetDesktopWindow(),_T("open"),_T("http://myweb.tiscali.co.uk/mccord/"),NULL,NULL,SW_MAXIMIZE);		
}

void CMainFrame::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	BCMenu popmenu;

	popmenu.LoadMenu(IDR_GRID_POPUP);

	static UINT toolbars[]=
	{
		IDR_MAINFRAME,
		IDR_TOOLBAR
	};
	popmenu.LoadToolbars(toolbars,2);

	
	BCMenu *psub = (BCMenu *)popmenu.GetSubMenu(0);
	psub->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this);
	popmenu.DestroyMenu();	
}

void CMainFrame::OnUpdateHideShowSidebar(CCmdUI* pCmdUI) 
{
	CMDIChildWnd* pMDIActive = MDIGetActive();
	if(pMDIActive == NULL) return;
	CScopeDoc* pDoc = (CScopeDoc*)pMDIActive->GetActiveDocument();
	if ( pDoc == NULL) return;

	CView* pView = pDoc->GetActiveView();
	if (pView != NULL)
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();
		
		if (pChild->m_bShowPanel == true) pCmdUI->SetCheck(1);
		else pCmdUI->SetCheck(0);
	}	
}

void CMainFrame::ComRealTimeScroll()
{
	/** Trigger must be disabled for best results **/
	/** Slow wavefroms only **/

	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	unsigned char c;
	unsigned char b1, b2;
	unsigned short signal; 
	int count = 0;
	double m_fDiv;
	bool m_bNoOPAMP = false;
	int ch;


	int buf,z;

	for (count = 0; count  < 100; count++) 
	{

		if (readchr(&c) == false) return;

		if ((c >> 7) == 0) b1 = c;
		else return;
			
		ch = (b1>>5)& 0x3;

		if (readchr(&c) == false) return;
		if ((c >> 7) == 1) b2 = c;
		else return;
			
		signal = (b1 & 0x1f) << 5 | (b2 & 0x1f);

		//0:	-1 to +1V
		//1:	-2.5 to +2.5V
		//2:	-5 to +5V
		//3:	-10 to +10V
		//4:	-25 to +25V
		//5:	-50 to +50V
		//6:	-100 to +100V
		//7:	-250 to +250V
		//8:	0 to 5V

		switch (pApp->m_nInputRange)  // m_FDiv = 1024 / Vpp e.g. 1024 / 2 = 512.0
		{
			case 0: m_fDiv = 512.0; break;
			case 1: m_fDiv = 204.8; break;
			case 2: m_fDiv = 102.4; break;
			case 3: m_fDiv = 51.2;  break;
			case 4: m_fDiv = 20.48; break;
			case 5: m_fDiv = 10.24; break;
			case 6: m_fDiv = 5.24;  break;
			case 7: m_fDiv = 2.048;  break;
			case 8: m_bNoOPAMP= true; break;
		}
				

		if (m_bNoOPAMP == false)
			buf = (int)(((float)(signal-512.0)/m_fDiv)*1000.0);
		else
			buf = (int)(((float)((-signal)/204.8))*1000.0);
		

		if(ch == 0) // channel 1
		{

			// Scroll array one place to the left 
			for (z=1;z<=pApp->m_nBufferSize-1;z++)
			{
				pApp->m_nCH1Volt[z] = pApp->m_nCH1Volt[z+1];
			}

			pApp->m_nCH1Volt[pApp->m_nBufferSize] = buf;	// add new item

		}

		if(ch == 1) // channel 2
		{

			// Scroll array one place to the left 
			for (z=1;z<=pApp->m_nBufferSize-1;z++)
			{
				pApp->m_nCH2Volt[z] = pApp->m_nCH2Volt[z+1];
			}

			pApp->m_nCH2Volt[pApp->m_nBufferSize] = buf;	// add new item

		}

		if(ch == 2) // channel 3
		{

			// Scroll array one place to the left 
			for (z=1;z<=pApp->m_nBufferSize-1;z++)
			{
				pApp->m_nCH3Volt[z] = pApp->m_nCH3Volt[z+1];
			}

			pApp->m_nCH3Volt[pApp->m_nBufferSize] = buf;	// add new item

		}

		if(ch == 3) // channel 4
		{

			// Scroll array one place to the left 
			for (z=1;z<=pApp->m_nBufferSize-1;z++)
			{
				pApp->m_nCH4Volt[z] = pApp->m_nCH4Volt[z+1];
			}

			pApp->m_nCH4Volt[pApp->m_nBufferSize] = buf;	// add new item

		}
	}


}

void CMainFrame::ComRealTimeBuffered()
{
	/** Trigger must be enabled for best results **/
	
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	unsigned char c;
	unsigned char b1, b2;
	unsigned short signal; // Upto 100 Hz 
	int count = 0,j;
	double m_fDiv;
	bool m_bNoOPAMP = false;
	int ch;



	for (count = 0; count  < 100; count++) // Old Method
	{
		if (readchr(&c) == false) return;
	
		if ((c >> 7) == 0) b1 = c;
		else continue;
			
		ch = (b1>>5)& 0x3;

		if (readchr(&c) == false) return;
		if ((c >> 7) == 1) b2 = c;
		else continue;
		

		signal = (b1 & 0x1f) << 5 | (b2 & 0x1f);


		//0:	-1 to +1V
		//1:	-2.5 to +2.5V
		//2:	-5 to +5V
		//3:	-10 to +10V
		//4:	-25 to +25V
		//5:	-50 to +50V
		//6:	-100 to +100V
		//7:	-250 to +250V
		//8:	0 to 5V
		switch (pApp->m_nInputRange)  // m_FDiv = 1024 / Vpp e.g. 1024 / 2 = 512.0
		{
			case 0: m_fDiv = 512.0; break;
			case 1: m_fDiv = 204.8; break;
			case 2: m_fDiv = 102.4; break;
			case 3: m_fDiv = 51.2;  break;
			case 4: m_fDiv = 20.48; break;
			case 5: m_fDiv = 10.24; break;
			case 6: m_fDiv = 5.24;  break;
			case 7: m_fDiv = 2.048;  break;
			case 8: m_bNoOPAMP= true; break;
		}
			
		if (ch == 0) // Channel 1
		{
			
			if (m_bNoOPAMP == false)
				bufferCH1[CH1_POS] = (int)(((float)(signal-512.0)/m_fDiv)*1000.0);
			else
				bufferCH1[CH1_POS] = (int)(((float)((-signal)/204.8))*1000.0);
		

			CH1_POS++;
			pApp->m_nPOS = CH1_POS;

			if (CH1_POS > pApp->m_nBufferSize) 
			{
				memset(pApp->m_nCH1Volt,0,10000);
				for(j = 0; j < pApp->m_nBufferSize; j++) pApp->m_nCH1Volt[j] = bufferCH1[j];
				CH1_POS = 0;
			}
		}
			
		if (ch == 1) // Channel 2
		{
			if (m_bNoOPAMP == false)
				bufferCH2[CH2_POS] = (int)(((float)(signal-512.0)/m_fDiv)*1000.0);
			else
				bufferCH2[CH2_POS] = (int)(((float)((-signal)/204.8))*1000.0);
		

			CH2_POS++;

			if (CH2_POS > pApp->m_nBufferSize) 
			{
				memset(pApp->m_nCH2Volt,0,10000);
				for(j = 0; j < pApp->m_nBufferSize; j++) pApp->m_nCH2Volt[j] = bufferCH2[j];
				CH2_POS = 0;
			}
		}

		if (ch == 2) // Channel 3
		{
			if (m_bNoOPAMP == false)
				bufferCH3[CH3_POS] = (int)(((float)(signal-512.0)/m_fDiv)*1000.0);
			else
				bufferCH3[CH3_POS] = (int)(((float)((-signal)/204.8))*1000.0);
		

			CH3_POS++;

			if (CH3_POS > pApp->m_nBufferSize) 
			{
				memset(pApp->m_nCH3Volt,0,10000);
				for(j = 0; j < pApp->m_nBufferSize; j++) pApp->m_nCH3Volt[j] = bufferCH3[j];
				CH3_POS = 0;
			}
		}

		if (ch == 3) // Channel 4
		{
			if (m_bNoOPAMP == false)
				bufferCH4[CH4_POS] = (int)(((float)(signal-512.0)/m_fDiv)*1000.0);
			else
				bufferCH4[CH4_POS] = (int)(((float)((-signal)/204.8))*1000.0);
		

			CH4_POS++;

			if (CH4_POS > pApp->m_nBufferSize) 
			{
				memset(pApp->m_nCH4Volt,0,10000);
				for(j = 0; j < pApp->m_nBufferSize; j++) pApp->m_nCH4Volt[j] = bufferCH4[j];
				CH4_POS = 0;
			}
		}

	}
}

void CMainFrame::OnViewAdSampling() 
{
	CMDIChildWnd* pMDIActive = MDIGetActive();
	if(pMDIActive == NULL) return;
	CScopeDoc* pDoc = (CScopeDoc*)pMDIActive->GetActiveDocument();
	if ( pDoc == NULL) return;
	m_Title.Format("Advanced Sampling Control Panel");
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	CreateOrActivateFrame(pApp->GetAdSamplingView(),RUNTIME_CLASS(CAdSamplingView));

}

void CMainFrame::OnEnableComms() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Reinital Comms */
	CloseHandle (m_hCom);
	InitalCom();

	m_bEnableCOMS = true;
}

void CMainFrame::OnDisableComms() 
{
	m_bEnableCOMS = false;
}

void CMainFrame::OnUpdateEnableComms(CCmdUI* pCmdUI) 
{
	if(m_bEnableCOMS == true)	pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}

void CMainFrame::OnUpdateDisableComms(CCmdUI* pCmdUI) 
{
	if(m_bEnableCOMS == false)	pCmdUI->SetCheck(1);
	else pCmdUI->SetCheck(0);
}
