// Scope.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "Scope.h"

#include "MainFrm.h"
#include "ChildFrm.h"  // For Split View
#include "ChildFrame2.h" // Normal View
#include "ScopeDoc.h"
#include "ScopeView.h"
#include "ControlsView.h"
#include "StatLink.h"
#include "AdSamplingView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScopeApp

BEGIN_MESSAGE_MAP(CScopeApp, CWinApp)
	//{{AFX_MSG_MAP(CScopeApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScopeApp construction

CScopeApp::CScopeApp()
{

//memset(m_nCH1,10,101);
	m_nInputRange = 1;	// 0: -1 to +1V
						// 1: -5 to +5V
						// 2: -10 to +10V
						// 3: -50 to +50V
						// 4: -100 to +100V
	m_nPOS = 0;

	m_nSampleMode = 1;  // real-time buffered
	m_SampleRateSelection = 7;


	m_nBufferSize = 1001;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CScopeApp object

CScopeApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CScopeApp initialization

BOOL CScopeApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("McCords Software"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	
	pDocTemplate = new CMultiDocTemplate(
		IDR_SCOPETYPE,
		RUNTIME_CLASS(CScopeDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CScopeView));
	AddDocTemplate(pDocTemplate);

	m_pControlsTemplate = new CMultiDocTemplate(
		IDR_SCOPETYPE,
		RUNTIME_CLASS(CScopeDoc),
		RUNTIME_CLASS(CChildFrame2), // custom MDI child frame
		RUNTIME_CLASS(CControlsView));
//	AddDocTemplate(m_pControlsTemplate);

	m_pAdSamplingTemplate = new CMultiDocTemplate(
		IDR_SCOPETYPE,
		RUNTIME_CLASS(CScopeDoc),
		RUNTIME_CLASS(CChildFrame2), //  MDI child frame
		RUNTIME_CLASS(CAdSamplingView));


	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;


	// This code replaces the MFC created menus with 
	// Ownerdrawn versions 
	pDocTemplate->m_hMenuShared=pMainFrame->NewMenu();
	pMainFrame->m_hMenuDefault=pMainFrame->NewDefaultMenu();

	// This simulates a window being opened if you don't have
	// a default window displayed at startup
	pMainFrame->OnUpdateFrameMenu(pMainFrame->m_hMenuDefault);


	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->InitialShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:

	/* Hyperlinks */
	CStaticLink m_wndLink1;
	CStaticLink m_wndLink2;
	CStaticLink m_wndLink3;
	CStaticLink m_wndLink4;
	CStaticLink m_wndLink5;

	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };


	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)

	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CScopeApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CScopeApp message handlers


CMultiDocTemplate* CScopeApp::GetControlsView()
{
	return m_pControlsTemplate;
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	/* Setup HyperLinks */

	m_wndLink1.m_link = _T("http://website.lineone.net/~colin_mccord/");
	m_wndLink2.m_link = _T("http://www.ulst.ac.uk");
	m_wndLink3.m_link = _T("http://www.ulst.ac.uk/courses/modules/courses/C190UJ.html");
	m_wndLink4.m_link = _T("http://www.engj.ulst.ac.uk/sidk/");
	m_wndLink5.m_link = _T("http://tree.engj.ulst.ac.uk/");

	m_wndLink1.SubclassDlgItem(IDC_CKM, this);
	m_wndLink2.SubclassDlgItem(IDC_UUJ, this);
	m_wndLink3.SubclassDlgItem(IDC_BENG, this);
	m_wndLink4.SubclassDlgItem(IDC_KATZEN, this);
	m_wndLink5.SubclassDlgItem(IDC_TUNER, this);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



CMultiDocTemplate* CScopeApp::GetAdSamplingView()
{
	return m_pAdSamplingTemplate;
}
