// Scope.h : main header file for the SCOPE application
//

#if !defined(AFX_SCOPE_H__CE239FD8_905A_4E14_A658_1D7C6FCC2D64__INCLUDED_)
#define AFX_SCOPE_H__CE239FD8_905A_4E14_A658_1D7C6FCC2D64__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "Color.h"
#include "ScopeDoc.h"	// Added by ClassView
#include "UsefulSplitterWnd.h"


/* Timers */
const int TIMER_CHECK_FOR_CHANGES = 101;
const int TIMER_COMMS = 102;



/* Default COMs*/
const int D_COM = 0;
const int D_BAUD = 8;
const int D_BYTE = 1;
const int D_PARITY = 2;
const int D_STOP = 0;
const int D_TIMER = 25;


const int HINT_OPEN = 32;

/////////////////////////////////////////////////////////////////////////////
// CScopeApp:
// See Scope.cpp for the implementation of this class
//

class CScopeApp : public CWinApp
{
public:
	CMultiDocTemplate* GetAdSamplingView();
	int m_nSampleMode;	// 0 = real-time scroll, 1 = real-time buffered

	int m_nBufferSize;
	int m_nPOS;

	int m_nCH1Volt[10004];	// Voltage * 1000
	int m_nCH2Volt[10004];	// Voltage * 1000
	int m_nCH3Volt[10004];	// Voltage * 1000
	int m_nCH4Volt[10004];	// Voltage * 1000


	int m_nInputRange;  //0:	-1 to +1V
						//1:	-2.5 to +2.5V
						//2:	-5 to +5V
						//3:	-10 to +10V
						//4:	-25 to +25V
						//5:	-50 to +50V
						//6:	-100 to +100V
						//7:	-250 to +250V
						//8:	0 to 5V

	int  m_SampleRateSelection;	

	CMultiDocTemplate* GetControlsView();
	CMultiDocTemplate* m_pControlsTemplate;
	CMultiDocTemplate* m_pAdSamplingTemplate;
	CMultiDocTemplate* pDocTemplate;


	CScopeApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScopeApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CScopeApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCOPE_H__CE239FD8_905A_4E14_A658_1D7C6FCC2D64__INCLUDED_)
