// ScopeDoc.cpp : implementation of the CScopeDoc class
//

#include "stdafx.h"
#include "Scope.h"

#include "ScopeDoc.h"
#include "ChildFrm.h"
#include "ScopeView.h"
#include "math.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CScopeDoc

IMPLEMENT_DYNCREATE(CScopeDoc, CDocument)

BEGIN_MESSAGE_MAP(CScopeDoc, CDocument)
	//{{AFX_MSG_MAP(CScopeDoc)
	ON_COMMAND(ID_POPUPMENU_HIDESHOWSIDEBAR, OnHideShowSidebar)
	ON_COMMAND(ID_GRID_CONFIGURATION, OnGridConfiguration)
	ON_COMMAND(ID_TOOLS_DEBUG_SINEWAVE, OnToolsDebugSinewave)
	ON_COMMAND(ID_DEBUG_RANDOM, OnDebugRandom)
	ON_UPDATE_COMMAND_UI(ID_POPUPMENU_HIDESHOWSIDEBAR, OnUpdateHideShowSidebar)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_FILE_EXPORT, OnFileExport)
	ON_COMMAND(ID_TOOLS_DEBUG_RANDOMWAVECH2, OnToolsDebugRandomwavech2)
	ON_COMMAND(ID_TOOLS_DEBUG_SINEWAVECH2, OnToolsDebugSinewavech2)
	ON_COMMAND(ID_POPUPMENU_DEBUG_CH3SINEWAVE, OnToolsDebugSinewavech3)
	ON_COMMAND(ID_POPUPMENU_DEBUG_CH3RANDOMWAVE, OnToolsDebugRandomwavech3)
	ON_COMMAND(ID_POPUPMENU_DEBUG_CH4SINEWAVE, OnToolsDebugSinewavech4)
	ON_COMMAND(ID_POPUPMENU_DEBUG_CH4RANDOMWAVE, OnToolsDebugRandomwavech4)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScopeDoc construction/destruction

CScopeDoc::CScopeDoc()
{
	m_bCH1_ENABLE = true;
	m_nTrigger = 0;

	m_nTriggerType = 0;		// 0 = NEG to POS, 1 = POS to NEG

	m_TimeBaseMUX = 1;		// Setup Scope Timebase muxliplier default same as sample rate 
	m_TimeBaseSelection =1;	// Selected Timebase
	
	m_nTriggerOffsetLevel = 0;
	m_nTriggerFormat = 0;		// Level Triggered
	m_Filename = _T("Untitled");
}

CScopeDoc::~CScopeDoc()
{
}

BOOL CScopeDoc::OnNewDocument()
{


	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	SetTitle(m_Filename);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CScopeDoc serialization

void CScopeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CScopeDoc diagnostics

#ifdef _DEBUG
void CScopeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CScopeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CScopeDoc commands

void CScopeDoc::OnHideShowSidebar() 
{
	CView* pView = GetActiveView();
	

	if (pView != NULL)	
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
		CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	
		SView->OnHideShowSideBar();
	}


}

CView* CScopeDoc::GetActiveView()
{
	/* 15/02/2002, by Colin McCord */

	CView* pView;
	POSITION pos = GetFirstViewPosition();
	if (pos != NULL)
	{
		pView = GetNextView(pos);
		return pView;
	}

	else return NULL;
}

void CScopeDoc::OnGridConfiguration() 
{
	CView* pView = GetActiveView();
	

	if (pView != NULL)	
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
		CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	
		SView->OnGridConfiguration();
	}

}

void CScopeDoc::OnToolsDebugSinewave() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Sine Wave, random AMP and Frequency */
	int i;

	double value;
	double a = 0.0;
	double freq = (double)(rand() % 99)+1;;
	double amp = (double)(rand() % 4)+1;

	/* Fill test CH1 */
	for (i = 0; i < 9999; i++)
	{
	
		value = amp * sin((2*3.14159 / freq) * a);
		pApp->m_nCH1Volt[i] = (short)(0+(500 * value));

		a = a + 1.0;
		if (a > freq) a = 1.0;
	}	

		
	
	



}

void CScopeDoc::OnDebugRandom() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Rand CH1 trace */
	int  i;
	for (i = 0; i < 9999; i++) 
	{
		pApp->m_nCH1Volt[i] = ((rand()%8000)*-1) + 4000;
	}
}




void CScopeDoc::OnUpdateHideShowSidebar(CCmdUI* pCmdUI) 
{
	CView* pView = GetActiveView();
	if (pView != NULL)
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();
		
		if (pChild->m_bShowPanel == true) pCmdUI->SetCheck(1);
		else pCmdUI->SetCheck(0);
	}	
}

void CScopeDoc::OnEditCopy() 
{
	CView* pView = GetActiveView();
	
	if (pView != NULL)	
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
		CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	
		SView->OnEditCopy();
	}
}

void CScopeDoc::OnFileExport() 
{
	CView* pView = GetActiveView();
	
	if (pView != NULL)	
	{
		CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
		CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	
		SView->OnFileExport();
	}
}



void CScopeDoc::OnToolsDebugRandomwavech2() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Rand CH2 trace */
	int  i;
	for (i = 0; i < 9999; i++) 
	{
		pApp->m_nCH2Volt[i] = ((rand()%8000)*-1) + 4000;
	}
}

void CScopeDoc::OnToolsDebugSinewavech2() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Sine Wave, random AMP and Frequency */
	int i;

	double value;
	double a = 0.0;
	double freq = (double)(rand() % 999)+1;;
	double amp = (double)(rand() % 10)+1;

	/* Fill test CH2 */
	for (i = 0; i < 9999; i++)
	{
		value = amp * sin((2*3.14159 / freq) * a);
		pApp->m_nCH2Volt[i] = (short)(0+(500 * value));

		a = a + 1.0;
		if (a > freq) a = 1.0;
	}		
}

void CScopeDoc::OnToolsDebugSinewavech3() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Sine Wave, random AMP and Frequency */
	int i;

	double value;
	double a = 0.0;
	double freq = (double)(rand() % 150)+1;;
	double amp = (double)(rand() % 10)+1;

	/* Fill test CH3 */
	for (i = 0; i < 9999; i++)
	{
		value = amp * sin((2*3.14159 / freq) * a);
		pApp->m_nCH3Volt[i] = (short)(0+(500 * value));

		a = a + 1.0;
		if (a > freq) a = 1.0;
	}	
}

void CScopeDoc::OnToolsDebugRandomwavech3() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Rand CH3 trace */
	int  i;
	for (i = 0; i < 9999; i++) 
	{
		pApp->m_nCH3Volt[i] = ((rand()%8000)*-1) + 4000;
	}
}

void CScopeDoc::OnToolsDebugSinewavech4() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Sine Wave, random AMP and Frequency */
	int i;

	double value;
	double a = 0.0;
	double freq = (double)(rand() % 500)+1;;
	double amp = (double)(rand() % 50)+1;

	/* Fill test CH4 */
	for (i = 0; i < 9999; i++)
	{
		value = amp * sin((2*3.14159 / freq) * a);
		pApp->m_nCH4Volt[i] = (short)(0+(500 * value));

		a = a + 1.0;
		if (a > freq) a = 1.0;
	}	
}

void CScopeDoc::OnToolsDebugRandomwavech4() 
{
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	/* Rand CH4 trace */
	int  i;
	for (i = 0; i < 9999; i++) 
	{
		pApp->m_nCH4Volt[i] = ((rand()%12000)*-1) + 4000;
	}
}

void CScopeDoc::CalTimeBaseMUX()
{
	/** Added 04/04/2002 by Colin McCoes **/

	CScopeApp* pApp = (CScopeApp*)AfxGetApp();

	double m_fTimeBase, m_fRawTimeBase, m_fSample_Rate;

	/* Possible TimeBases */
	switch (m_TimeBaseSelection)
	{
		case 0: m_fTimeBase = 50e-6;	break;	//.50uS/DIV
		case 1: m_fTimeBase = 0.1e-3;	break;	//.1mS/DIV
		case 2: m_fTimeBase = 0.2e-3;	break;	//.2mS/DIV
		case 3: m_fTimeBase = 0.5e-3;	break;	//.5mS/DIV
		case 4: m_fTimeBase = 1e-3;		break;	//1mS/DIV
		case 5: m_fTimeBase = 2e-3;		break;	//2mS/DIV
		case 6: m_fTimeBase = 5e-3;		break;	//5mS/DIV
		case 7: m_fTimeBase = 10e-3;	break;	//10mS/DIV
		case 8: m_fTimeBase = 20e-3;	break;	//20mS/DIV
		case 9: m_fTimeBase = 50e-3;	break;	//50mS/DIV
		case 10: m_fTimeBase = 0.1;		break;	//.1S/DIV
		case 11: m_fTimeBase = 0.2;		break;	//.2S/DIV
		case 12: m_fTimeBase = 0.5;		break;	//.5S/DI
		case 13: m_fTimeBase = 1;		break;	//1S/DIV
		case 14: m_fTimeBase = 10;		break;	//10S/DIV

		default: m_fTimeBase = 10e-3;	break;

	}
	
	/* Possible Sample Rates */
	switch (pApp->m_SampleRateSelection)
	{
		case 0: m_fSample_Rate = 1;		break;
		case 1: m_fSample_Rate = 10;	break;
		case 2: m_fSample_Rate = 20;	break;
		case 3: m_fSample_Rate = 50;	break;
		case 4: m_fSample_Rate = 100;	break;
		case 5: m_fSample_Rate = 200;	break;
		case 6: m_fSample_Rate = 500;	break;
		case 7: m_fSample_Rate = 1.00e3; break;
		case 8: m_fSample_Rate = 2.00e3; break;
		case 9: m_fSample_Rate = 5.00e3; break;
		case 10: m_fSample_Rate = 10.0e3; break;
		case 11: m_fSample_Rate = 20.0e3; break;
		case 12: m_fSample_Rate = 50.0e3; break;
		case 13: m_fSample_Rate = 100.0e3; break;
		case 14: m_fSample_Rate = 200.0e3; break;

		default: m_fSample_Rate = 1000; break;
	}

	m_fRawTimeBase = (1.0/m_fSample_Rate) * 10.0;

	if(m_fTimeBase >= m_fRawTimeBase) 	m_TimeBaseMUX = (int)(m_fTimeBase / m_fRawTimeBase);
	else m_TimeBaseMUX = ((int)(m_fRawTimeBase / m_fTimeBase)) * -1;

}



void CScopeDoc::OnFileSave() 
{
	// 07/04/2002 by CKM
	if((_access(m_Filename, 0)) == -1)
	{
		OnFileSaveAs();
	}
	else
	{
		Save();
	}	
}

void CScopeDoc::OnFileSaveAs() 
{
	// 07/04/2002 by CKM
	CFileDialog dlg (FALSE, _T("*.sdf"), m_Filename, OFN_HIDEREADONLY,_T("Scope Data File(*.sdf)|*.sdf||"));

	if (IDOK == dlg.DoModal())
	{
		/* Check for existence */
		if( (_access(dlg.GetPathName(), 0 )) != -1 )
		{
			if(AfxMessageBox("File '" + dlg.GetPathName() + "' Already exists. Do you want to replace the existing file ?", MB_YESNO | MB_ICONINFORMATION) != IDYES)
				return;
		}
	
		m_Filename = dlg.GetPathName();
		Save();
	}	
}

void CScopeDoc::OnChangedViewList() 
{
	// TODO: Add your specialized code here and/or call the base class
	SetTitle(m_Filename);
	CDocument::OnChangedViewList();
}

void CScopeDoc::Save()
{
	// 07/04/2002 by CKM
	CView* pView = GetActiveView();
	if (pView == NULL)	return;
	
	CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
	CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	

	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	FILE *infile;

	int i = 0;

	if((infile=fopen(m_Filename,"wr"))==NULL) 
	{
		AfxMessageBox("Unable to create file");
		return;
	}

	rewind(infile);


	/* Save Channel 1,2,3 & 4 */
	for(i=0;i<10000;i++) fprintf(infile,"%d\n",pApp->m_nCH1Volt[i]);
	for(i=0;i<10000;i++) fprintf(infile,"%d\n",pApp->m_nCH2Volt[i]);
	for(i=0;i<10000;i++) fprintf(infile,"%d\n",pApp->m_nCH3Volt[i]);
	for(i=0;i<10000;i++) fprintf(infile,"%d\n",pApp->m_nCH4Volt[i]);


	/* Save Variables */
	fprintf(infile,"%d\n",	SView->x);
	fprintf(infile,"%d\n",	SView->y);
	fprintf(infile,"%d\n",SView->m_nCH1POS);
	fprintf(infile,"%d\n",SView->m_nCH2POS);
	fprintf(infile,"%d\n",SView->m_nCH3POS);
	fprintf(infile,"%d\n",SView->m_nCH4POS);
	fprintf(infile,"%d\n",SView->m_nCH1_Offset);
	fprintf(infile,"%d\n",SView->m_nCH2_Offset);
	fprintf(infile,"%d\n",SView->m_nCH3_Offset);
	fprintf(infile,"%d\n",SView->m_nCH4_Offset);
	fprintf(infile,"%d\n",pApp->m_nInputRange);
	fprintf(infile,"%d\n",pApp->m_nSampleMode);
	fprintf(infile,"%d\n",pApp->m_SampleRateSelection);
	fprintf(infile,"%d\n",m_bCH1_ENABLE);
	fprintf(infile,"%d\n",m_bCH2_ENABLE);
	fprintf(infile,"%d\n",m_bCH3_ENABLE);
	fprintf(infile,"%d\n",m_bCH4_ENABLE);
	fprintf(infile,"%d\n",m_TimeBaseSelection);
	fprintf(infile,"%d\n",m_nCH1_VOLTS);
	fprintf(infile,"%d\n",m_nCH2_VOLTS);
	fprintf(infile,"%d\n",m_nCH3_VOLTS);
	fprintf(infile,"%d\n",m_nCH4_VOLTS);
	fprintf(infile,"%d\n",m_nTrigger);
	fprintf(infile,"%d\n",m_nTriggerType);
	fprintf(infile,"%d\n",SView->m_ColorGridBackGround);
	fprintf(infile,"%d\n",SView->m_nRefreshRate);

	fclose(infile);

	SetTitle(m_Filename);

}

void CScopeDoc::OnFileOpen() 
{
	// 07/04/2002 by CKM
	CView* pView = GetActiveView();
	if (pView == NULL) return;
	
	CChildFrame* pChild = (CChildFrame*)pView->GetParentFrame();	
	CScopeView* SView =  (CScopeView*) pChild->m_wndSplitter.GetPane(0,0);
	
	CScopeApp* pApp = (CScopeApp*)AfxGetApp();
	FILE *infile;
	int i;
	int temp;

	CFileDialog dlg (TRUE, _T("*.sdf"), m_Filename, OFN_HIDEREADONLY,_T("Scope Data File(*.sdf)|*.sdf||"));

	if (IDOK == dlg.DoModal())
	{
		m_Filename = dlg.GetPathName();

		if((infile=fopen(m_Filename,"rw"))==NULL) 
		{
			AfxMessageBox("Unable to open file");
			return;
		}

		rewind(infile);

		/* Open Channel 1 */
		for(i=0;i<10000;i++) 
		{
			fscanf(infile,"%d\n",&temp);
			pApp->m_nCH1Volt[i] = temp;
		}

		/* Open Channel 2 */
		for(i=0;i<10000;i++) 
		{
			fscanf(infile,"%d\n",&temp);
			pApp->m_nCH2Volt[i] = temp;
		}

		/* Open Channel 3 */
		for(i=0;i<10000;i++) 
		{
			fscanf(infile,"%d\n",&temp);
			pApp->m_nCH3Volt[i] = temp;
		}
	
		/* Open Channel 4 */
		for(i=0;i<10000;i++) 
		{
			fscanf(infile,"%d\n",&temp);
			pApp->m_nCH4Volt[i] = temp;
		}

		fscanf(infile,"%d\n",&SView->x);
		fscanf(infile,"%d\n",&SView->y);
		fscanf(infile,"%d\n",&SView->m_nCH1POS);
		fscanf(infile,"%d\n",&SView->m_nCH2POS);
		fscanf(infile,"%d\n",&SView->m_nCH3POS);
		fscanf(infile,"%d\n",&SView->m_nCH4POS);
		fscanf(infile,"%d\n",&SView->m_nCH1_Offset);
		fscanf(infile,"%d\n",&SView->m_nCH2_Offset);
		fscanf(infile,"%d\n",&SView->m_nCH3_Offset);
		fscanf(infile,"%d\n",&SView->m_nCH4_Offset);
		fscanf(infile,"%d\n",&pApp->m_nInputRange);
		fscanf(infile,"%d\n",&pApp->m_nSampleMode);
		fscanf(infile,"%d\n",&pApp->m_SampleRateSelection);
		fscanf(infile,"%d\n",&m_bCH1_ENABLE);
		fscanf(infile,"%d\n",&m_bCH2_ENABLE);
		fscanf(infile,"%d\n",&m_bCH3_ENABLE);
		fscanf(infile,"%d\n",&m_bCH4_ENABLE);
		fscanf(infile,"%d\n",&m_TimeBaseSelection);
		fscanf(infile,"%d\n",&m_nCH1_VOLTS);
		fscanf(infile,"%d\n",&m_nCH2_VOLTS);
		fscanf(infile,"%d\n",&m_nCH3_VOLTS);
		fscanf(infile,"%d\n",&m_nCH4_VOLTS);
		fscanf(infile,"%d\n",&m_nTrigger);
		fscanf(infile,"%d\n",&m_nTriggerType);
		fscanf(infile,"%d\n",&SView->m_ColorGridBackGround);
		fscanf(infile,"%d\n",&SView->m_nRefreshRate);
	



		fclose(infile);
		
		UpdateAllViews(NULL,HINT_OPEN,NULL);

		SView->PrepareGrid();
		SView->PrepareTraces();
		SView->OnDrawGrid();
		SView->OnDrawCH1();
		SView->OnDrawCH2();
		SView->OnDrawCH3();
		SView->OnDrawCH4();
	

	}	


	SetTitle(m_Filename);
}


