// ScopeDoc.h : interface of the CScopeDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCOPEDOC_H__A3BCF5BC_0DAA_4F1A_B78B_5648EC35E848__INCLUDED_)
#define AFX_SCOPEDOC_H__A3BCF5BC_0DAA_4F1A_B78B_5648EC35E848__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <io.h>



class CScopeDoc : public CDocument
{
protected: // create from serialization only
	CScopeDoc();
	DECLARE_DYNCREATE(CScopeDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScopeDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnChangedViewList();
	//}}AFX_VIRTUAL

// Implementation
public:
	void Save();
	void CalTimeBaseMUX();
	int m_nTriggerType;

	int m_nTriggerOffsetLevel;
	int m_nTriggerFormat; // 0 = level, 1 = edge

	int m_nCH1_VOLTS;		// Channel 1 volts per div
	int m_nCH2_VOLTS;		// Channel 2 volts per div
	int m_nCH3_VOLTS;		// Channel 3 volts per div
	int m_nCH4_VOLTS;		// Channel 4 volts per div

	bool m_bCH1_ENABLE;		// Channel 1 enabled/disabled
	bool m_bCH2_ENABLE;		// Channel 2 enabled/disabled
	bool m_bCH3_ENABLE;		// Channel 3 enabled/disabled
	bool m_bCH4_ENABLE;		// Channel 4 enabled/disabled

	int	 m_TimeBaseMUX;			// Setup Scope Timebase muxliplier 
	int m_TimeBaseSelection;


	int m_nTrigger;			// 0 = ch1, 1 = ch2, 2 = ch3 , 3 = ch4, 4 = all;

	CString m_Filename;

	CView* GetActiveView();


	virtual ~CScopeDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CScopeDoc)
	afx_msg void OnHideShowSidebar();
	afx_msg void OnGridConfiguration();
	afx_msg void OnToolsDebugSinewave();
	afx_msg void OnDebugRandom();
	afx_msg void OnUpdateHideShowSidebar(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnFileExport();
	afx_msg void OnToolsDebugRandomwavech2();
	afx_msg void OnToolsDebugSinewavech2();
	afx_msg void OnToolsDebugSinewavech3();
	afx_msg void OnToolsDebugRandomwavech3();
	afx_msg void OnToolsDebugSinewavech4();
	afx_msg void OnToolsDebugRandomwavech4();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCOPEDOC_H__A3BCF5BC_0DAA_4F1A_B78B_5648EC35E848__INCLUDED_)
