// ScopeView.h : interface of the CScopeView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCOPEVIEW_H__A8365032_B3DA_476E_9BFB_84A4D0A4F23B__INCLUDED_)
#define AFX_SCOPEVIEW_H__A8365032_B3DA_476E_9BFB_84A4D0A4F23B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include  <io.h>

const int nTimerRefresh = 303;



class CScopeView : public CView
{
protected: // create from serialization only
	CScopeView();
	DECLARE_DYNCREATE(CScopeView)

// Attributes
public:
	CScopeDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CScopeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnPrepareDC(CDC* pDC, CPrintInfo* pInfo = NULL);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Trigger();
	void OnDrawCH4();
	void OnDrawCH3();

	void OnDrawCH2();
	int m_nRefreshRate;		// Refresh Rate in Milliseconds
	CFont* ChangeFont(CDC *pDC, long Height, BYTE PitchAndFamily, long Weight);
	void OnFileExport();
	void PrepareTraces();
	void OnHideShowSideBar();
	void OnGridConfiguration();
	void OnEditCopy();

	int m_nTriggerCH1;
	int m_nTriggerCH2;
	int m_nTriggerCH3;
	int m_nTriggerCH4;

	int m_nVPD_CH1;
	int m_nVPD_CH2;
	int m_nVPD_CH3;
	int m_nVPD_CH4;

	void OnDrawCH1();


	RECT m_ClientRect;





	int m_nCH1POS;
	int m_nCH2POS;
	int m_nCH3POS;
	int m_nCH4POS;

	int m_nCH1_Offset;
	int m_nCH2_Offset;
	int m_nCH3_Offset;
	int m_nCH4_Offset;


	void OnDrawGrid();
	CScopeDoc * pDoc;
	CScopeApp* pApp;
	bool m_bChangeZeroCH1;
	bool m_bChangeZeroCH2;
	bool m_bChangeZeroCH3;
	bool m_bChangeZeroCH4;

	bool m_bChangeOffsetCH1;
	bool m_bChangeOffsetCH2;
	bool m_bChangeOffsetCH3;
	bool m_bChangeOffsetCH4;




	void PrepareGrid();
	int m_nGridY[5001];		// Y Grid coordinate array
	int m_nGridX[5001];		// X Grid coordinate array
	int m_nClientWidth;
	int m_nClientHeight;
	int x;
	int y;
	CBitmap *m_bitmapCH1;  // Point to CH1 Bitmap
	CBitmap *m_bitmapCH2;  // Point to CH2 Bitmap
	CBitmap *m_bitmapCH3;  // Point to CH3 Bitmap
	CBitmap *m_bitmapCH4;  // Point to CH4 Bitmap
	


	CPen* penGrid;
	CDC     m_dcGrid;
	COLORREF m_ColorGridBackGround;

	CPen* penCH1;
	CDC   m_dcCH1;

	CDC	m_dcCH2;
	CPen* penCH2;

	CDC	m_dcCH3;
	CPen* penCH3;

	CDC	m_dcCH4;
	CPen* penCH4;



	virtual ~CScopeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	HANDLE DDBToDIB( CBitmap& bitmap, DWORD dwCompression, CPalette* pPal);
	BOOL WriteDIB( CString szFile, HANDLE hDIB);
	//{{AFX_MSG(CScopeView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in ScopeView.cpp
inline CScopeDoc* CScopeView::GetDocument()
   { return (CScopeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCOPEVIEW_H__A8365032_B3DA_476E_9BFB_84A4D0A4F23B__INCLUDED_)
